/* $Id: mga1064_main.h,v 1.6 1999/04/06 13:34:47 becka Exp $
******************************************************************************

   Matrox Mystique (1064sg) -- special structures

   Copyright (C) 1997		Jonas Borgstrm
   Copyright (C) 1997		Hartmut Niemann
   Copyright (C) 1997           Matthias Grimrath

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#ifndef _MGA1064_MAIN_H_
#define _MGA1064_MAIN_H_

struct myst_info {
	int blkmode;
};

/* textmemory layout of the Mystique framebuffer */

typedef struct mgatext {
	kgiu16 ca;
	kgiu8 font1;
	kgiu8 pad3_9[7];
	kgiu8 font2;
	kgiu8 pad11_15[5];
} mgatext;

/* Mystique specific ioctls.  Hopefully don't collide */
#define	CHIP_MYST_GETINFO    IOR(CHIPSET, 0x80, struct myst_info)
#define CHIP_MYST_GETRAYPOS  IOR(CHIPSET, 0x81, kgis32)
#define CHIP_MYST_WAITRAYPOS IOC(CHIPSET, 0x82)

#ifdef __KERNEL__
struct chipset_private
{
	struct common_private cp;
	
	struct mem_region pseudo_dma;
	struct kgi_mmio_region dmawin_mmio;
	struct kgi_mmio_region pingpong_mmio;
 	struct myst_info info;
	struct kgi_accel pingpong;
};

/* Convenience and compile macros */
#define PINGPONG (&private->pingpong)

#define virtwidth_NUM 13
extern const uint virtwidth[virtwidth_NUM];

/* Implemented in the graphics driver */
void pingpong_exec(struct kgi_accel *accel,struct kgi_accel_buffer *peng);
void pingpong_wait(struct kgi_accel *accel);

#endif /* __KERNEL__ */

#endif /* _MGA1064_MAIN_H_ */
